#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>	
#include <time.h>
#include <mmsystem.h>

#include "ljud.h"

//flyttade den hit, vet inte varfr :)
short * mixBuffer;
float sync;
bool NoiseTime;

//jag r van vid dessa
typedef unsigned int int32;
typedef unsigned char char8;


#define cPi 3.14159265

enum 
{
  SONGLENGTH = 32,
  PATTERNLENGTH = 16,
  NUMCHANNELS = 5,	// 4
  TEMPO=5000
};

//hr r sjlva lten, sger vilket pattern som spelar nr av vilken kanal. 
//tiden r horisontell. 0 = inget pattern.
char seq[NUMCHANNELS][SONGLENGTH] =
{
	{0,0,0,0, 0,0,0,0, 1,1,1,1, 1,1,1,1, 1,1,1,1, 1,1,1,1, 1,1,1,1, 0,0,1,1},//
	{2,2,2,2, 2,2,2,2, 0,0,0,0, 3,3,3,3, 2,2,2,2, 0,0,0,0, 2,2,2,2, 3,3,3,3},
	{3,3,3,3, 3,3,3,3, 0,0,0,0, 2,2,2,2, 3,3,3,3, 0,0,0,0, 3,3,3,3, 2,2,2,2},
	{0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0, 4,4,4,4, 4,4,4,4, 4,4,4,4},
	{0,0,8,8, 9,9,9,9, 0,0,7,8, 9,9,9,9, 9,9,9,8, 7,7,7,8, 9,9,9,9, 7,7,9,9}
};

//s=sharp allts med korstecken dvs hjd en halv ton
//enum {C=0,Cs=1,D=2,Ds=3,E=4,F=5,Fs=6,G=7,Gs=8,A=9,As=10,B=11,C2=12,Cs2=13,D2=14,Ds2=15,E2=16,F2=17,Fs2=18,G2=19,Gs2=20,A2=21,As2=22,B2=23,C3=24,x=-1};

enum {C=0,E=4,B=11,D2=14,E2=16,G2=19,x=-1};


//de olika patterns som finns. x betyder "ingen not hr".
char patterns[9][PATTERNLENGTH] = 
{
  {  x,  x,  E,  x,      x,  x,  E,  x,      x,  x,  E,  x,    x, E2,  E,  x},
  {  x, D2,  x,  x,      x,  x,  x,  x,      x,  x,  x,  x,   E2,  x,  x,  x},
  {  x,  x,  x,  x,      x,  x,  x,  x,      x,  E,  x,  x,   G2,  x,  x,  x},
  {  E,  E,  x, E2,      x,  E,  E,  x,     E2,  x,  x,  E2,   x,  x,  E,  x},
  {  x,  x,  x,  x,      x,  x,  x,  x,      x,  x,  x,  x,    x,  x,  x,  x},
  {  x,  x,  x,  x,      x,  x,  x,  x,      x,  x,  x,  x,    x,  x,  x,  x},
  {  C,  x,  x,  x,      x,  x,  C,  x,      x,  x,  C,  x,    C,  x,  B,  C},		// trummor
  {  C,  x,  C,  x,      x,  x,  x,  x,      B,  B,  B,  B,    B,  B,  B,  B},		// trummor
  {  C,  x,  x,  x,      B,  x,  x,  x,      C,  x,  x,  x,    B,  x,  x,  x}		// trummor
};
  

//en kanal
struct MelodyChannel
{
  int pos;      //oscillatorn position
  int32 delta;    //dess hastighet

  char8 cutoff;   //filteregenskaper
  char8 resonance;

  char transpose; //oktaver +/-
  char lfo; //om filtret ska svepa upp och ner
  char square; //square wave
  
  float envPos;  //fr envelopet
  float filterPos,filterDelta;

  int on;
};


//kanalernas startvrden.
//chans som i CHANnelS, inte typ trevlig risk :D 
MelodyChannel chans[NUMCHANNELS] =
{
  {0,0,10,250,0,0,1},{0,0,170,130,1,0,0},{0,0,128,248,1,1,0},{0,0,30,254,0,1,0},{0,0,128,128,3,0,2},
};

//var vi r i lten: songPos i sextondelar (noter allts), songTime i samples
int songPos=0;
int songTime=0;






/*
//filtrera ett sample t gngen = sltt men va fan :)
inline int filterWork(int _sample, MelodyChannel &chan) 
{
  float cut=float(chan.cutoff/511.0f) + chan.envPos/10.3f;//float(songTime&65535)/65536.0f;
  if (chan.lfo) cut += sinf(songTime*0.00002213f)*0.4f+0.3f;
  if (cut<0) cut=0; //fr skerhets skull : den hr raden kan nog tas bort men inte nsta
  if (cut>1) cut=1;
  
  float reso = float(chan.resonance) / 255.0f;
  float c = 2.0f-2.0f*cosf(float(cPi)*cut/3);

  chan.filterDelta += (float(_sample)-chan.filterPos)*c;
  chan.filterPos += chan.filterDelta;
  chan.filterDelta *= reso;

  return (int)chan.filterPos;
}
*/
void ljud_fillBuffer(int buffer) 
{
	short *fillPos = mixBuffer + buffer*bufferSize*2; //var ska vi fylla?

	for (int i=0; i<bufferSize; i++) //loopa fram
	{
		if (songTime%TEMPO== 0) //om det r dags...
		{  //stega fram i lten
			for (int i=0; i<NUMCHANNELS; i++)
			{
				int pat = seq[i][(songPos/PATTERNLENGTH)%SONGLENGTH]; //kolla vilket pattern som ska spelas, och loopa lten (AND med 15)
				chans[i].on=false;

				if (pat)
				{
					int note=patterns[pat-1][songPos%PATTERNLENGTH]; //kolla vilken ton som ska spelas

					if (note!=-1)
					{
						
						if (i == 4)
						{						
							NoiseTime = false;
							if (note == B)
								NoiseTime = true;
						}


						//rknar ut oscillatordelta frn en ton
						chans[i].delta = (0xffffffff / 44100) * ((440.0f/16.0f) * powf(2.0f,float((note+ chans[i].transpose*12)+3)/12));
						chans[i].pos=0; //0x80000000;
						chans[i].on=1;
						chans[i].envPos=1;
					}
				}
			}
				
			songPos++; //fram
		}

		int wave=0; //current sample

		//g igenom kanalerna
		for (int c=0; c<NUMCHANNELS; c++)
		{
			int sample=0;
			if (chans[c].on) //om den r p
			{
				sample=int(chans[c].pos>>20); //saw wave

				if (chans[c].square==1)              //gr om till square om vi ska det
				  sample=(sample<0) ? -2000 : 2000;
				else if (chans[c].square==2)              //gr om till sin om vi ska ha det
				  sample=sinf(sample*cPi/2000.0)*18000;
        
				if (c == 4)
				{
					sync = 2;
					if (NoiseTime)
					{
						sample= sample*0.5+(rand()&0x3fff);
						sync = 0;
					}
					chans[c].delta*=.9994;
				}
				
			}	



		//		wave += filterWork(sample,chans[c]);  //filtrera	



				float cut=float(chans[c].cutoff/511.0f) + chans[c].envPos/10.3f;//float(songTime&65535)/65536.0f;
				if (chans[c].lfo) cut += sinf(songTime*0.00002213f)*0.4f+0.3f;
				if (cut<0) cut=0; //fr skerhets skull : den hr raden kan nog tas bort men inte nsta
				if (cut>1) cut=1;

				float reso = float(chans[c].resonance) / 255.0f;
				float d = 2-2*cosf(float(cPi)*cut/3);

				chans[c].filterDelta += (float(sample)-chans[c].filterPos)*d;
				chans[c].filterPos += chans[c].filterDelta;
				chans[c].filterDelta *= reso;

  
				wave += (int)chans[c].filterPos;









				chans[c].envPos *= 0.9995;       //snk envelopet
				chans[c].pos += chans[c].delta;  //g framt i saw waven
		}

		if (wave<-32767) wave=-32767; //klippeti klipp
		else if (wave>32767) wave=32767;

		*fillPos++= wave;  //kta stereo :)
		*fillPos++= wave;
    
		songTime++; //fram en sample
		
	}
};